﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;

namespace HeuristicLab.Clients.Hive.Views {
  /// <summary>
  /// The base class for visual representations of items.
  /// </summary>
  [View("Hive Experiment Manager View")]
  [Content(typeof(HiveExperimentManagerClient), false)]
  public partial class HiveExperimentManagerView : ItemView {

    public new HiveExperimentManagerClient Content {
      get { return (HiveExperimentManagerClient)base.Content; }
      set { base.Content = value; }
    }

    /// <summary>
    /// Initializes a new instance of <see cref="ItemBaseView"/>.
    /// </summary>
    public HiveExperimentManagerView() {
      InitializeComponent();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      Content_HiveExperimentsChanged(this, EventArgs.Empty);
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
    }

    protected override void RegisterContentEvents() {
      this.Content.HiveExperimentsChanged += new EventHandler(Content_HiveExperimentsChanged);
    }

    protected override void DeregisterContentEvents() {
      this.Content.HiveExperimentsChanged -= new EventHandler(Content_HiveExperimentsChanged);
    }

    private void Content_HiveExperimentsChanged(object sender, EventArgs e) {
      if (Content != null) {
        this.hiveExperimentListView.Content = Content.HiveExperiments;
      }
    }
  }
}
